# File generated from our OpenAPI spec by Stainless. See CONTRIBUTING.md for details.

from __future__ import annotations

from typing import List, Union, Iterable
from typing_extensions import Literal, Required, TypedDict

__all__ = [
    "AutogeneratedDraftTestCaseCreateParams",
    "TestCaseData",
    "TestCaseDataArtifactSchemaGeneration",
    "TestCaseDataArtifactSchemaGenerationExpectedExtraInfo",
    "TestCaseDataArtifactSchemaGenerationExpectedExtraInfoChunkExtraInfoSchema",
    "TestCaseDataArtifactSchemaGenerationExpectedExtraInfoChunkExtraInfoSchemaChunk",
    "TestCaseDataArtifactSchemaGenerationExpectedExtraInfoStringExtraInfoSchema",
    "TestCaseDataSchemaGenerationBase",
    "TestCaseDataSchemaGenerationBaseExpectedExtraInfo",
    "TestCaseDataSchemaGenerationBaseExpectedExtraInfoChunkExtraInfoSchema",
    "TestCaseDataSchemaGenerationBaseExpectedExtraInfoChunkExtraInfoSchemaChunk",
    "TestCaseDataSchemaGenerationBaseExpectedExtraInfoStringExtraInfoSchema",
]


class AutogeneratedDraftTestCaseCreateParams(TypedDict, total=False):
    account_id: Required[str]
    """The ID of the account that owns the given entity."""

    approved: Required[bool]
    """Boolean to track whether or not the draft test case is approved"""

    schema_type: Required[Literal["GENERATION"]]
    """An enumeration."""

    test_case_data: Required[TestCaseData]
    """The data for the test case in a format matching the provided schema_type"""

    topic_str: str


class TestCaseDataArtifactSchemaGenerationExpectedExtraInfoChunkExtraInfoSchemaChunk(TypedDict, total=False):
    metadata: Required[object]

    text: Required[str]


class TestCaseDataArtifactSchemaGenerationExpectedExtraInfoChunkExtraInfoSchema(TypedDict, total=False):
    chunks: Required[Iterable[TestCaseDataArtifactSchemaGenerationExpectedExtraInfoChunkExtraInfoSchemaChunk]]

    schema_type: Literal["CHUNKS"]


class TestCaseDataArtifactSchemaGenerationExpectedExtraInfoStringExtraInfoSchema(TypedDict, total=False):
    info: Required[str]

    schema_type: Literal["STRING"]


TestCaseDataArtifactSchemaGenerationExpectedExtraInfo = Union[
    TestCaseDataArtifactSchemaGenerationExpectedExtraInfoChunkExtraInfoSchema,
    TestCaseDataArtifactSchemaGenerationExpectedExtraInfoStringExtraInfoSchema,
]


class TestCaseDataArtifactSchemaGeneration(TypedDict, total=False):
    artifact_ids_filter: Required[List[str]]

    input: Required[str]

    expected_extra_info: TestCaseDataArtifactSchemaGenerationExpectedExtraInfo

    expected_output: str


class TestCaseDataSchemaGenerationBaseExpectedExtraInfoChunkExtraInfoSchemaChunk(TypedDict, total=False):
    metadata: Required[object]

    text: Required[str]


class TestCaseDataSchemaGenerationBaseExpectedExtraInfoChunkExtraInfoSchema(TypedDict, total=False):
    chunks: Required[Iterable[TestCaseDataSchemaGenerationBaseExpectedExtraInfoChunkExtraInfoSchemaChunk]]

    schema_type: Literal["CHUNKS"]


class TestCaseDataSchemaGenerationBaseExpectedExtraInfoStringExtraInfoSchema(TypedDict, total=False):
    info: Required[str]

    schema_type: Literal["STRING"]


TestCaseDataSchemaGenerationBaseExpectedExtraInfo = Union[
    TestCaseDataSchemaGenerationBaseExpectedExtraInfoChunkExtraInfoSchema,
    TestCaseDataSchemaGenerationBaseExpectedExtraInfoStringExtraInfoSchema,
]


class TestCaseDataSchemaGenerationBase(TypedDict, total=False):
    input: Required[str]

    expected_extra_info: TestCaseDataSchemaGenerationBaseExpectedExtraInfo

    expected_output: str


TestCaseData = Union[TestCaseDataArtifactSchemaGeneration, TestCaseDataSchemaGenerationBase]
